package me.unurled.sacredrealms.sr.components.entity;

import org.bukkit.NamespacedKey;
import org.bukkit.entity.Entity;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.SpawnerSpawnEvent;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;
import org.jetbrains.annotations.NotNull;

public class Spawner implements Listener {

  private static final NamespacedKey ENTITY_TYPE = new NamespacedKey("SR", "ENTITY_TYPE");

  @EventHandler(priority = EventPriority.HIGH)
  public static void onEntitySpawn(@NotNull SpawnerSpawnEvent e) {
    // get entity pdc and check if it has a custom entity type
    Entity entity = e.getEntity();
    PersistentDataContainer pdc = entity.getPersistentDataContainer();
    if (pdc.has(ENTITY_TYPE)) {
      String entityType = pdc.get(ENTITY_TYPE, PersistentDataType.STRING);
      if (entityType != null) return;
    }
    e.setCancelled(true);
  }
}
