package me.unurled.sacredrealms.sr.components.item.abilities;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

/** Represents an ability that an item can have. TODO: Implement this class */
@SuppressWarnings("unused")
public enum Ability {
  TEST("TEST", "Test", "Test", 1, 1, 1);

  private final String id;
  private final String name;
  private final String description;
  private final Integer cooldown;
  private final Integer manaCost;
  private final Integer damage;

  Ability(
      String id,
      String name,
      String description,
      Integer cooldown,
      Integer manaCost,
      Integer damage) {
    this.id = id;
    this.name = name;
    this.description = description;
    this.cooldown = cooldown;
    this.manaCost = manaCost;
    this.damage = damage;
  }

  public static @Nullable Ability getAbility(@NotNull String id) {
    for (Ability ability : Ability.values()) {
      if (ability.getId().equalsIgnoreCase(id)) {
        return ability;
      }
    }
    return null;
  }

  public String getId() {
    return id;
  }

  public String getName() {
    return name;
  }

  public String getDescription() {
    return description;
  }

  public Integer getCooldown() {
    return cooldown;
  }

  public Integer getManaCost() {
    return manaCost;
  }

  public Integer getDamage() {
    return damage;
  }

  @Override
  public String toString() {
    return "Ability{"
        + "name='"
        + name
        + '\''
        + ", description='"
        + description
        + '\''
        + ", cooldown="
        + cooldown
        + ", manaCost="
        + manaCost
        + ", damage="
        + damage
        + '}';
  }
}
