package me.unurled.sacredrealms.sr.components.item.enchantments;

import org.jetbrains.annotations.Nullable;

public enum Enchantment {
  TEST("TEST", "test", "", 255);

  private final String id;
  private final String name;
  private final String description;
  private final Integer maxLevel;

  Enchantment(String id, String name, String description, Integer maxLevel) {
    this.id = id;
    this.name = name;
    this.description = description;
    this.maxLevel = maxLevel;
  }

  public static @Nullable Enchantment getEnchantment(String id) {
    for (Enchantment enchantment : Enchantment.values()) {
      if (enchantment.getId().equalsIgnoreCase(id)) {
        return enchantment;
      }
    }
    return null;
  }

  public String getId() {
    return id;
  }

  public String getName() {
    return name;
  }

  public String getDescription() {
    return description;
  }

  public Integer getMaxLevel() {
    return maxLevel;
  }
}
