package me.unurled.sacredrealms.sr.components.player.listener;

import me.unurled.sacredrealms.sr.components.player.PlayerManager;
import me.unurled.sacredrealms.sr.components.player.SRPlayer;
import me.unurled.sacredrealms.sr.managers.Manager;
import org.bukkit.GameMode;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.inventory.ItemStack;
import org.jetbrains.annotations.NotNull;

public class PlayerBlockEvent implements Listener {

  public boolean isClientBuilder(@NotNull Player p) {
    PlayerManager pm = Manager.getInstance(PlayerManager.class);
    SRPlayer sr = pm.getPlayer(p.getUniqueId());
    return sr != null && sr.isClientBuilder();
  }

  @EventHandler
  public void onBreakBlock(@NotNull BlockBreakEvent event) {
    Player p = event.getPlayer();
    if (p.getGameMode().equals(GameMode.CREATIVE)) {
      return;
    }

    if (isClientBuilder(p)) return;

    // make block break client side
    event.setCancelled(true);

    p.sendBlockChange(event.getBlock().getLocation(), Material.AIR.createBlockData());
    // TEST: check if it remove durability from items
    p.playSound(p.getLocation(), event.getBlock().getBlockSoundGroup().getBreakSound(), 1, 1);
    event.setDropItems(true);
  }

  @EventHandler
  public void onPlaceBlock(@NotNull BlockPlaceEvent e) {
    Player p = e.getPlayer();
    if (p.getGameMode().equals(GameMode.CREATIVE)) {
      return;
    }

    if (isClientBuilder(p)) return;

    // make block place client side
    e.setCancelled(true);
    p.sendBlockChange(e.getBlock().getLocation(), e.getBlockReplacedState().getBlockData());
    if (p.getInventory().getItemInMainHand().getAmount() != 1) {
      p.getInventory()
          .getItemInMainHand()
          .setAmount(p.getInventory().getItemInMainHand().getAmount() - 1);
    } else {
      p.getInventory().setItem(p.getInventory().getHeldItemSlot(), new ItemStack(Material.AIR));
    }
    p.playSound(p.getLocation(), e.getBlock().getBlockSoundGroup().getPlaceSound(), 1, 1);
  }
}
